Require Import bool.
Require Import connectives.
Require Import div_mod.
Require Import logic.
Require Import nat.
Require Import relations.
Parameter divides : nat.nat -> nat.nat -> Prop.
Axiom quotient : forall (n:nat.nat), forall (m:nat.nat), forall (q:nat.nat), (logic.eq (nat.nat) m (nat.times n q)) -> divides n m.
Axiom match_divides_prop : forall (n:nat.nat), forall (m:nat.nat), forall (return_type:Prop), (forall (q:nat.nat), (logic.eq (nat.nat) m (nat.times n q)) -> return_type) -> (divides n m) -> return_type.
Definition reflexive_divides : relations.reflexive (nat.nat) divides := fun (x:nat.nat) => ((((quotient) (x)) (x)) (nat.S nat.O)) (((((((logic.rewrite_r) (nat.nat)) (nat.times x (nat.S nat.O))) (fun (__:nat.nat) => logic.eq (nat.nat) __ (nat.times x (nat.S nat.O)))) (((logic.refl) (nat.nat)) (nat.times x (nat.S nat.O)))) (x)) ((nat.times_n_1) (x))).
Definition divides_to_div_mod_spec : forall (n:nat.nat), forall (m:nat.nat), (nat.lt nat.O n) -> (divides n m) -> div_mod.div_mod_spec m n (div_mod.div m n) nat.O := fun (n:nat.nat) => fun (m:nat.nat) => fun (posn:nat.lt nat.O n) => (fun (_clearme:divides n m) => ((((((match_divides_prop) (n)) (m)) (div_mod.div_mod_spec m n (div_mod.div m n) nat.O)) (fun (q:nat.nat) => fun (eqm:logic.eq (nat.nat) m (nat.times n q)) => (((((((div_mod.div_mod_spec_intro) (m)) (n)) (div_mod.div m n)) (nat.O)) (posn)) (((((((logic.eq_ind_r) (nat.nat)) (nat.times n q)) (fun (x:nat.nat) => logic.eq (nat.nat) x (nat.plus (nat.times (div_mod.div x n) n) nat.O))) (((((((logic.eq_ind_r) (nat.nat)) (nat.times q n)) (fun (x:nat.nat) => logic.eq (nat.nat) x (nat.plus (nat.times (div_mod.div x n) n) nat.O))) (((((((logic.eq_ind_r) (nat.nat)) (q)) (fun (x:nat.nat) => logic.eq (nat.nat) (nat.times q n) (nat.plus (nat.times x n) nat.O))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n q)) (fun (__:nat.nat) => logic.eq (nat.nat) __ (nat.plus (nat.times q n) nat.O))) (((((((logic.rewrite_l) (nat.nat)) (m)) (fun (__:nat.nat) => logic.eq (nat.nat) __ (nat.plus (nat.times q n) nat.O))) (((((((logic.rewrite_r) (nat.nat)) (nat.times n q)) (fun (__:nat.nat) => logic.eq (nat.nat) m (nat.plus __ nat.O))) (((((((logic.rewrite_l) (nat.nat)) (m)) (fun (__:nat.nat) => logic.eq (nat.nat) m (nat.plus __ nat.O))) (((((((logic.rewrite_l) (nat.nat)) (m)) (fun (__:nat.nat) => logic.eq (nat.nat) m __)) (((logic.refl) (nat.nat)) (m))) (nat.plus m nat.O)) ((nat.plus_n_O) (m)))) (nat.times n q)) (eqm))) (nat.times q n)) (((nat.commutative_times) (q)) (n)))) (nat.times n q)) (eqm))) (nat.times q n)) (((nat.commutative_times) (q)) (n)))) (div_mod.div (nat.times q n) n)) ((((div_mod.div_times) (q)) (n)) (posn)))) (nat.times n q)) (((nat.commutative_times) (n)) (q)))) (m)) (eqm))))) (_clearme))).
Definition divides_to_mod_O : forall (n:nat.nat), forall (m:nat.nat), (nat.lt nat.O n) -> (divides n m) -> logic.eq (nat.nat) (div_mod.mod m n) nat.O := fun (n:nat.nat) => fun (m:nat.nat) => fun (posn:nat.lt nat.O n) => (fun (divnm:divides n m) => (((((((((div_mod.div_mod_spec_to_eq2) (m)) (n)) (div_mod.div m n)) (div_mod.mod m n)) (div_mod.div m n)) (nat.O)) ((((div_mod.div_mod_spec_div_mod) (m)) (n)) (posn))) (((((divides_to_div_mod_spec) (n)) (m)) (posn)) (divnm)))).
Definition mod_O_to_divides : forall (n:nat.nat), forall (m:nat.nat), (nat.lt nat.O n) -> (logic.eq (nat.nat) (div_mod.mod m n) nat.O) -> divides n m := fun (n:nat.nat) => fun (m:nat.nat) => fun (auto:nat.lt nat.O n) => (fun (auto':logic.eq (nat.nat) (div_mod.mod m n) nat.O) => (((((quotient) (n)) (m)) (div_mod.div m n)) (((((((logic.rewrite_l) (nat.nat)) (nat.times n (div_mod.div m n))) (fun (__:nat.nat) => logic.eq (nat.nat) __ (nat.times n (div_mod.div m n)))) (((logic.refl) (nat.nat)) (nat.times n (div_mod.div m n)))) (m)) (((((((logic.rewrite_r) (nat.nat)) (nat.minus m nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.times n (div_mod.div m n)) __)) (((((((logic.rewrite_l) (nat.nat)) (div_mod.mod m n)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.times n (div_mod.div m n)) (nat.minus m __))) (((((((logic.rewrite_l) (nat.nat)) (nat.times (div_mod.div m n) n)) (fun (__:nat.nat) => logic.eq (nat.nat) __ (nat.minus m (div_mod.mod m n)))) (((div_mod.eq_times_div_minus_mod) (m)) (n))) (nat.times n (div_mod.div m n))) (((nat.commutative_times) (div_mod.div m n)) (n)))) (nat.O)) (auto'))) (m)) ((nat.minus_n_O) (m)))))).
Definition divides_n_n : forall (n:nat.nat), divides n n := fun (n:nat.nat) => (reflexive_divides) (n).
Definition dividesb : nat.nat -> nat.nat -> bool.bool := fun (n:nat.nat) => fun (m:nat.nat) => nat.eqb (div_mod.mod m n) nat.O.
Definition dividesb_true_to_divides : forall (n:nat.nat), forall (m:nat.nat), (logic.eq (bool.bool) (dividesb n m) bool.true) -> divides n m := fun (n:nat.nat) => fun (m:nat.nat) => ((((((connectives.match_Or_prop) (nat.lt nat.O n)) (logic.eq (nat.nat) nat.O n)) ((logic.eq (bool.bool) (dividesb n m) bool.true) -> divides n m)) (fun (posn:nat.lt nat.O n) => (fun (divbnm:logic.eq (bool.bool) (dividesb n m) bool.true) => (((((mod_O_to_divides) (n)) (m)) (posn)) ((((nat.eqb_true_to_eq) (div_mod.mod m n)) (nat.O)) (divbnm)))))) (fun (eqnO:logic.eq (nat.nat) nat.O n) => (((((((logic.eq_ind) (nat.nat)) (nat.O)) (fun (x_1:nat.nat) => (logic.eq (bool.bool) (dividesb x_1 m) bool.true) -> divides x_1 m)) ((((((nat.sym_eq_match_nat_type_O) (nat.nat)) (m)) (fun (p:nat.nat) => div_mod.mod_aux m m p)) (fun (y:nat.nat) => (logic.eq (bool.bool) (nat.eqb y nat.O) bool.true) -> divides nat.O m)) (fun (eqbmO:logic.eq (bool.bool) (nat.eqb m nat.O) bool.true) => (((((((logic.eq_ind_r) (nat.nat)) (nat.O)) (fun (x:nat.nat) => divides nat.O x)) ((divides_n_n) (nat.O))) (m)) ((((nat.eqb_true_to_eq) (m)) (nat.O)) (eqbmO)))))) (n)) (eqnO)))) ((((nat.le_to_or_lt_eq) (nat.O)) (n)) ((nat.le_O_n) (n))).
Definition dividesb_false_to_not_divides : forall (n:nat.nat), forall (m:nat.nat), (logic.eq (bool.bool) (dividesb n m) bool.false) -> connectives.Not (divides n m) := fun (n:nat.nat) => fun (m:nat.nat) => ((((((connectives.match_Or_prop) (nat.lt nat.O n)) (logic.eq (nat.nat) nat.O n)) ((logic.eq (bool.bool) (dividesb n m) bool.false) -> connectives.Not (divides n m))) (fun (posn:nat.lt nat.O n) => (fun (ndivbnm:logic.eq (bool.bool) (dividesb n m) bool.false) => (((((logic.not_to_not) (divides n m)) (logic.eq (nat.nat) (div_mod.mod m n) nat.O)) ((((divides_to_mod_O) (n)) (m)) (posn))) ((((nat.eqb_false_to_not_eq) (div_mod.mod m n)) (nat.O)) (ndivbnm)))))) (fun (eqnO:logic.eq (nat.nat) nat.O n) => (((((((logic.eq_ind) (nat.nat)) (nat.O)) (fun (x_1:nat.nat) => (logic.eq (bool.bool) (dividesb x_1 m) bool.false) -> connectives.Not (divides x_1 m))) ((((((nat.sym_eq_match_nat_type_O) (nat.nat)) (m)) (fun (p:nat.nat) => div_mod.mod_aux m m p)) (fun (y:nat.nat) => (logic.eq (bool.bool) (nat.eqb y nat.O) bool.false) -> connectives.Not (divides nat.O m))) (((((nat.nat_case) (m)) (fun (__:nat.nat) => (logic.eq (bool.bool) (nat.eqb __ nat.O) bool.false) -> connectives.Not (divides nat.O __))) ((((nat.sym_eq_eqb) (nat.O)) (fun (y:(nat.nat -> bool.bool)) => (logic.eq (nat.nat) m nat.O) -> (logic.eq (bool.bool) (y nat.O) bool.false) -> connectives.Not (divides nat.O nat.O))) (((((nat.sym_eq_filter_nat_type_O) (nat.nat -> bool.bool)) (nat.eqb_body)) (fun (y:(nat.nat -> bool.bool)) => (logic.eq (nat.nat) m nat.O) -> (logic.eq (bool.bool) (y nat.O) bool.false) -> connectives.Not (divides nat.O nat.O))) (((nat.sym_eq_eqb_body_O) (fun (y:(nat.nat -> bool.bool)) => (logic.eq (nat.nat) m nat.O) -> (logic.eq (bool.bool) (y nat.O) bool.false) -> connectives.Not (divides nat.O nat.O))) ((((((nat.sym_eq_match_nat_type_O) (bool.bool)) (bool.true)) (fun (q:nat.nat) => bool.false)) (fun (y:bool.bool) => (logic.eq (nat.nat) m nat.O) -> (logic.eq (bool.bool) y bool.false) -> connectives.Not (divides nat.O nat.O))) (fun (auto:logic.eq (nat.nat) m nat.O) => (fun (auto':logic.eq (bool.bool) bool.true bool.false) => (((((logic.not_to_not) (divides nat.O nat.O)) (logic.eq (bool.bool) bool.true bool.false)) (fun (auto'':divides nat.O nat.O) => (((((((logic.rewrite_l) (bool.bool)) (bool.true)) (fun (__:bool.bool) => logic.eq (bool.bool) bool.true __)) (((logic.refl) (bool.bool)) (bool.true))) (bool.false)) (auto')))) (bool.not_eq_true_false))))))))) (fun (a:nat.nat) => fun (__:logic.eq (nat.nat) m (nat.S a)) => (fun (_0:logic.eq (bool.bool) (nat.eqb (nat.S a) nat.O) bool.false) => (((connectives.nmk) (divides nat.O (nat.S a))) (fun (_clearme:divides nat.O (nat.S a)) => ((((((match_divides_prop) (nat.O)) (nat.S a)) (connectives.False)) (fun (q:nat.nat) => fun (auto:logic.eq (nat.nat) (nat.S a) (nat.times nat.O q)) => ((((logic.absurd) (logic.eq (nat.nat) nat.O (nat.S a))) (((((((logic.rewrite_r) (nat.nat)) (n)) (fun (__1:nat.nat) => logic.eq (nat.nat) __1 (nat.S a))) (((((((logic.rewrite_l) (nat.nat)) (nat.S a)) (fun (__1:nat.nat) => logic.eq (nat.nat) __1 (nat.S a))) (((logic.refl) (nat.nat)) (nat.S a))) (n)) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__1:nat.nat) => logic.eq (nat.nat) (nat.S a) __1)) (((((((logic.rewrite_r) (nat.nat)) (nat.times q nat.O)) (fun (__1:nat.nat) => logic.eq (nat.nat) (nat.S a) __1)) (((((((logic.rewrite_l) (nat.nat)) (nat.times nat.O q)) (fun (__1:nat.nat) => logic.eq (nat.nat) (nat.S a) __1)) (auto)) (nat.times q nat.O)) (((nat.commutative_times) (nat.O)) (q)))) (nat.O)) ((nat.times_n_O) (q)))) (n)) (eqnO)))) (nat.O)) (eqnO))) ((nat.not_eq_O_S) (a))))) (_clearme))))))))) (n)) (eqnO)))) ((((nat.le_to_or_lt_eq) (nat.O)) (n)) ((nat.le_O_n) (n))).
Definition decidable_divides : forall (n:nat.nat), forall (m:nat.nat), logic.decidable (divides n m) := fun (n:nat.nat) => fun (m:nat.nat) => ((((((connectives.match_Or_prop) (logic.eq (bool.bool) (dividesb n m) bool.true)) (logic.eq (bool.bool) (dividesb n m) bool.false)) (logic.decidable (divides n m))) (fun (auto:logic.eq (bool.bool) (dividesb n m) bool.true) => ((((connectives.or_introl) (divides n m)) (connectives.Not (divides n m))) ((((dividesb_true_to_divides) (n)) (m)) (((((((logic.rewrite_r) (bool.bool)) (bool.true)) (fun (__:bool.bool) => logic.eq (bool.bool) __ bool.true)) (((logic.refl) (bool.bool)) (bool.true))) (dividesb n m)) (auto)))))) (fun (auto:logic.eq (bool.bool) (dividesb n m) bool.false) => ((((connectives.or_intror) (divides n m)) (connectives.Not (divides n m))) ((((dividesb_false_to_not_divides) (n)) (m)) (((((((logic.rewrite_r) (bool.bool)) (bool.false)) (fun (__:bool.bool) => logic.eq (bool.bool) __ bool.false)) (((logic.refl) (bool.bool)) (bool.false))) (dividesb n m)) (auto)))))) ((bool.true_or_false) (dividesb n m)).
Definition divides_to_dividesb_true : forall (n:nat.nat), forall (m:nat.nat), (nat.lt nat.O n) -> (divides n m) -> logic.eq (bool.bool) (dividesb n m) bool.true := fun (n:nat.nat) => fun (m:nat.nat) => fun (posn:nat.lt nat.O n) => (fun (divnm:divides n m) => (((((((connectives.match_Or_prop) (logic.eq (bool.bool) (dividesb n m) bool.true)) (logic.eq (bool.bool) (dividesb n m) bool.false)) (logic.eq (bool.bool) (dividesb n m) bool.true)) (fun (auto:logic.eq (bool.bool) (dividesb n m) bool.true) => (((((((logic.rewrite_r) (bool.bool)) (bool.true)) (fun (__:bool.bool) => logic.eq (bool.bool) __ bool.true)) (((logic.refl) (bool.bool)) (bool.true))) (dividesb n m)) (auto)))) (fun (ndivbnm:logic.eq (bool.bool) (dividesb n m) bool.false) => (((connectives.falsity) (logic.eq (bool.bool) (dividesb n m) bool.true)) ((((logic.absurd) (divides n m)) (divnm)) ((((dividesb_false_to_not_divides) (n)) (m)) (((((((logic.rewrite_r) (bool.bool)) (bool.false)) (fun (__:bool.bool) => logic.eq (bool.bool) __ bool.false)) (((logic.refl) (bool.bool)) (bool.false))) (dividesb n m)) (ndivbnm))))))) ((bool.true_or_false) (dividesb n m)))).
Definition not_divides_to_dividesb_false : forall (n:nat.nat), forall (m:nat.nat), (nat.lt nat.O n) -> (connectives.Not (divides n m)) -> logic.eq (bool.bool) (dividesb n m) bool.false := fun (n:nat.nat) => fun (m:nat.nat) => fun (posn:nat.lt nat.O n) => (((((((connectives.match_Or_prop) (logic.eq (bool.bool) (dividesb n m) bool.true)) (logic.eq (bool.bool) (dividesb n m) bool.false)) ((connectives.Not (divides n m)) -> logic.eq (bool.bool) (dividesb n m) bool.false)) (fun (divbnm:logic.eq (bool.bool) (dividesb n m) bool.true) => (fun (ndivnm:connectives.Not (divides n m)) => (((connectives.falsity) (logic.eq (bool.bool) (dividesb n m) bool.false)) ((((logic.absurd) (divides n m)) ((((dividesb_true_to_divides) (n)) (m)) (((((((logic.rewrite_r) (bool.bool)) (bool.true)) (fun (__:bool.bool) => logic.eq (bool.bool) __ bool.true)) (((logic.refl) (bool.bool)) (bool.true))) (dividesb n m)) (divbnm)))) (ndivnm)))))) (fun (auto:logic.eq (bool.bool) (dividesb n m) bool.false) => (fun (auto':connectives.Not (divides n m)) => (((((((logic.rewrite_r) (bool.bool)) (bool.false)) (fun (__:bool.bool) => logic.eq (bool.bool) __ bool.false)) (((logic.refl) (bool.bool)) (bool.false))) (dividesb n m)) (auto))))) ((bool.true_or_false) (dividesb n m))).
